%
% Simulation: Marginal Effects
%

clear

cd 'G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
path='G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';

casel=12;

for casel=1:25

load([path '\output\mat\Results_2013_KAPPA1.mat']);
addpath([path '\functions\']);
PARA_out

PARA.TS1=zeros(n,1);
PARA.t1=zeros(n,1);
PARA.t0=zeros(n,1);

PARA.TS0=zeros(n,1);
PARA.T0=zeros(n,1);
PARA.T1=zeros(n,1);

%
% Make Regions Perfectly Similar
%
PARA.lambda0=mean(PARA.lambda0).* ones(n,1);
PARA.L0=PARA.lambda0.*PARA.LBAR;
PARA.pi0=1./PARA.n .* ones(n,n);
PARA.w0=mean(PARA.w0).* ones(n,1);
PARA.v0=mean(PARA.v0).* ones(n,1);
PARA.t0=mean(PARA.t0).* ones(n,1);
PARA.t1=PARA.t0;

PARA.T0=mean(PARA.T0).* ones(n,1);
PARA.TS1=PARA.lambda0.*PARA.LBAR.*PARA.T0./sum(PARA.T0.*PARA.lambda0.*PARA.LBAR);
PARA.TS1(isnan(PARA.TS1))=0;
PARA.TS0=PARA.TS1;

PARA.iota0BACK=PARA.iota;
PARA.iota=zeros(n,1);

PARA.a0_BARBACK = PARA.a0_BAR;
PARA.a0BACK=PARA.a0;
PARA.a0_BAR = mean(PARA.a0_BAR).*ones(n,1);
PARA.a0=mean(PARA.a0).* ones(n,1);

PARA.d0BACK=PARA.d0;
PARA.droad_zeroBACK=PARA.droad_zero;
PARA.PolygonNeigBACK=PARA.PolygonNeig;
PARA.NumOfLinksBACK=PARA.NumOfLinks;

PARA.droad_zero=mean(mean(PARA.droad_zero)).*ones(n,n);
PARA.PolygonNeig=1.*ones(n,n).*abs(eye(n)-1);
PARA.NumOfLinks=sum(PARA.PolygonNeig,2);
%!!!!!!!!!!!!!!!!!!
PARA.NumOfLinks=ones(n,1);
%!!!!!!!!!!!!!!!!!!

tinf0 = exp(PARA.kappa_AA.*PARA.PolygonNeig.*PARA.droad_zero);
tinf0(PARA.PolygonNeig==0)=inf;
PARA.d0=TradeCosts(tinf0,PARA);
PARA.d_ch=ones(n,n);

if (casel==10 || casel==20 )
    %PARA.m_ch=1./PARA.m2;
    %PARA.m_ch=PARA.m2./mean(PARA.m2);
end
if (casel==11 || casel==21 )
    PARA.B_ch=1./PARA.B0;
    PARA.B_ch=PARA.B0./mean(PARA.B0);
end
if (casel==12 || casel==22 )

    PARA.a0_BAR = PARA.a0_BARBACK;
    
end
if (casel==13 || casel==23 )

    PARA.droad_zero=PARA.droad_zeroBACK;
    
end
if (casel==14 || casel==24 )
    PARA.H_ch=1./PARA.H0;
    PARA.H_ch=PARA.H0./mean(PARA.H0);
end
if (casel==15 || casel==25 )
    PARA.iota=PARA.iota0BACK;
end

if  casel==1 || (casel>=10 && casel<=15) || (casel>=20 && casel<=25)

    T_lev=PARA.T0;

    for z = 1:n

        T1=T_lev;
        T1(z)=T1(z)+100;

        PARA.t1=((sum(T1.*PARA.lambda0.*PARA.LBAR))./(sum(PARA.w0.*PARA.lambda0.*PARA.LBAR))).*ones(n,1);
        if casel>=20
            PARA.t1=zeros(n,1);
        end
        PARA.TS1=PARA.lambda0.*PARA.LBAR.*T1./sum(T1.*PARA.lambda0.*PARA.LBAR);

        disp(['************** Wage PC, z: ' num2str(z) ', casel: ' num2str(casel) ' ****************']);    
        if (casel>=10 & casel<20) | casel==1 | z<=1
             [U_ch_w,PARA_w]=solveCounterfactual_w(PARA);
        end
         U_ch_ct10(z,1,casel)=U_ch_w(z);
         dwdT(z,1,casel)=PARA_w.w_ch(z);
         dLdT(z,1,casel)=PARA_w.lambda_ch(z);
         dvdT(z,1,casel)=PARA_w.v_ch(z);
         dpdT(z,1,casel)=PARA_w.pi_ch(z,z); 
         dadT(z,1,casel)=PARA_w.a_ch(z); 
         dddT(z,1,casel)=PARA_w.d_ch(z,z); 

        if (casel>=10 & casel<20) | casel==1 | z==1
             [U_ch_a,PARA_a]=solveCounterfactual_a(PARA);
        end
        U_ch_ct10(z,2,casel)=U_ch_a(z);
        dwdT(z,2,casel)=PARA_a.w_ch(z);
        dLdT(z,2,casel)=PARA_a.lambda_ch(z);
        dvdT(z,2,casel)=PARA_a.v_ch(z);
        dpdT(z,2,casel)=PARA_a.pi_ch(z,z); 
        dadT(z,2,casel)=PARA_a.a_ch(z); 
        dddT(z,2,casel)=PARA_a.d_ch(z,z); 

    end


    TS_lev=PARA.TS0;
    for z = 1:n
        PARA.TS1=TS_lev;
        PARA.TS1(z)=PARA.TS1(z)+0.00001;
        T1=PARA.TS1.*PARA.TBAR./(PARA.lambda0.*PARA.LBAR);
        PARA.t1=((sum(T1.*PARA.lambda0.*PARA.LBAR))./(sum(PARA.w0.*PARA.lambda0.*PARA.LBAR))).*ones(n,1);
        if casel>=20
            PARA.t1=zeros(n,1);
        end
        PARA.TS1=PARA.lambda0.*PARA.LBAR.*T1./sum(T1.*PARA.lambda0.*PARA.LBAR);

        disp(['************** Trade Cost Lev z: ' num2str(z) ', casel: ' num2str(casel) ' ****************']);
        if (casel>=10 & casel<20) | casel==1 | z<=1
             [U_ch_d,PARA_d]=solveCounterfactual_d(PARA);
        end
        U_ch_t1e6(z,3,casel)=U_ch_d(z);
        dwdT(z,3,casel)=PARA_d.w_ch(z);
        dLdT(z,3,casel)=PARA_d.lambda_ch(z);
        dvdT(z,3,casel)=PARA_d.v_ch(z);
        dpdT(z,3,casel)=PARA_d.pi_ch(z,z);
        dadT(z,3,casel)=PARA_d.a_ch(z); 
        dddT(z,3,casel)=PARA_d.d_ch(z,z); 

    end

end

end

save([path '\output\mat\MWE3_sim.mat'])

asdfasdf

load([path '\output\mat\MWE3_sim.mat'])

%
% B_ch
%
%[dLdT(:,1,11),dLdT(:,1,21),dvdT(:,1,11),dvdT(:,1,21)]

figure
    FIG=scatter(log(PARA.B0),[(U_ch_ct10(:,1,11)./U_ch_ct10(:,1,21))])
    xlabel('Log location attractiveness ($B_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\W_dUdT_B0.png']);
    
figure
    FIG=scatter(log(PARA.B0),[(U_ch_ct10(:,2,11)./U_ch_ct10(:,2,21))])
    xlabel('Log location attractiveness ($B_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\A_dUdT_B0.png']);
    
figure
    FIG=scatter(log(PARA.B0),[(U_ch_t1e6(:,3,11)./U_ch_t1e6(:,3,21))])
    xlabel('Log location attractiveness ($B_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\D_dUdT_B0.png']);

    
FIG=scatter(log(PARA.B0),[(dvdT(:,1,11)./dvdT(:,1,21))])
FIG=scatter(log(PARA.B0),[(dLdT(:,1,11)./dLdT(:,1,21))])
FIG=scatter(log(PARA.B0),[(dpdT(:,1,11)./dpdT(:,1,21))])
FIG=scatter(log(PARA.B0),[(dwdT(:,1,11)./dwdT(:,1,21))])

%
% a_ch
%

corr(dadT(:,1,22).*PARA.a0, dLdT(:,1,22).*PARA.L0)
corr(dadT(:,1,22).*PARA.a0, dwdT(:,1,22).*PARA.w0)
corr(dadT(:,1,22).*PARA.a0, dvdT(:,1,22).*PARA.v0)

corr(PARA.a0_BARBACK, dwdT(:,1,22).*PARA.w0)
corr(PARA.a0_BARBACK, dLdT(:,1,22).*PARA.L0)
corr(PARA.a0_BARBACK, dvdT(:,1,22).*PARA.v0)

corr(sum(PARA.d0BACK,2), dvdT(:,1,23).*PARA.v0)
corr(sum(PARA.d0BACK,2), dwdT(:,1,23).*PARA.w0)
corr(sum(PARA.d0BACK,2), dLdT(:,1,23).*PARA.L0)




format longg
dadT(:,1,12)./dadT(:,1,22)./((dLdT(:,1,12)./dLdT(:,1,22)).^PARA.mu), 

dadT(:,1,12)

corr([dadT(:,1,12)./dadT(:,1,22), dvdT(:,1,12)./dvdT(:,1,22)])

corr([dadT(:,1,12)./dadT(:,1,22), dwdT(:,1,12)./dwdT(:,1,22)])

corr([dadT(:,1,12)./dadT(:,1,22), dLdT(:,1,12)./dLdT(:,1,22)])

[dataimport,dataimport2] = xlsread(['G:\Public Economics\Forschung\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol2\output\xls\output.xlsx'],'Full Model 2013 Ka 1');
[dadT(:,1,12)./dadT(:,1,22),dataimport(:,9)]

corr(dLdT(:,1,12)./dLdT(:,1,22),dataimport(:,9))


figure
    FIG=scatter(log(PARA.a0_BARBACK),[(U_ch_ct10(:,1,12)./U_ch_ct10(:,1,22))])
    xlabel('Log production amenities net of transfers ($\bar{a}_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\W_dUdT_a0.png']);

figure
    FIG=scatter(log(PARA.a0_BARBACK),[(U_ch_ct10(:,2,12)./U_ch_ct10(:,2,22))])
    xlabel('Log production amenities net of transfers ($\bar{a}_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\A_dUdT_a0.png']);    

figure
    FIG=scatter(log(PARA.a0_BARBACK),[(U_ch_t1e6(:,3,12)./U_ch_t1e6(:,3,22))])
    xlabel('Log production amenities net of transfers ($\bar{a}_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\D_dUdT_a0.png']);    
    
FIG=scatter(log(PARA.a0),[(dvdT(:,1,12)./dvdT(:,1,22))])
FIG=scatter(log(PARA.a0),[(dLdT(:,1,12)./dLdT(:,1,22))])
FIG=scatter(log(PARA.a0),[(dpdT(:,1,12)./dpdT(:,1,22))])
FIG=scatter(log(PARA.a0),[(dwdT(:,1,12)./dwdT(:,1,22))])

%
% d_ch
%
figure
    A=log(sum(PARA.d0BACK,2));
    B=[(U_ch_ct10(:,1,13)./U_ch_ct10(:,1,23))];
    FIG=scatter(A,B)
    xlabel('Log sum of trade costs ($\sum_{i} d_{ni}$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\W_dUdT_d0.png']);

figure
    A=log(sum(PARA.d0BACK,2));
    B=[(U_ch_ct10(:,2,13)./U_ch_ct10(:,2,23))];
    FIG=scatter(A,B)
    xlabel('Log sum of trade costs ($\sum_{i} d_{ni}$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\A_dUdT_d0.png']);

figure
    A=log(sum(PARA.d0BACK,2));
    B=[(U_ch_t1e6(:,3,13)./U_ch_t1e6(:,3,23))];
    FIG=scatter(A,B)
    xlabel('Log sum of trade costs ($\sum_{i} d_{ni}$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\D_dUdT_d0.png']);
    
    
FIG=scatter(log(sum(PARA.d0BACK,2)),[(dvdT(:,3,13)./dvdT(:,3,23))])
FIG=scatter(log(sum(PARA.d0BACK,2)),[(dLdT(:,3,13)./dLdT(:,3,23))])
FIG=scatter(log(sum(PARA.d0BACK,2)),[(dpdT(:,3,13)./dpdT(:,3,23))])
FIG=scatter(log(sum(PARA.d0BACK,2)),[(dwdT(:,3,13)./dwdT(:,3,23))])

%
% H_ch
%
figure
    FIG=scatter(log(PARA.H0),[(U_ch_ct10(:,1,14)./U_ch_ct10(:,1,24))])
    xlabel('Log housing supply ($H_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\W_dUdT_H0.png']);
    
figure
    FIG=scatter(log(PARA.H0),[(U_ch_ct10(:,2,14)./U_ch_ct10(:,2,24))])
    xlabel('Log housing supply ($H_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\A_dUdT_H0.png']);

figure
    FIG=scatter(log(PARA.H0),[(U_ch_t1e6(:,3,14)./U_ch_t1e6(:,3,24))])
    xlabel('Log housing supply ($H_n$)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\D_dUdT_H0.png']);
    
FIG=scatter(log(PARA.H0),[(dvdT(:,1,14)./dvdT(:,1,24))])
FIG=scatter(log(PARA.H0),[(dLdT(:,1,14)./dLdT(:,1,24))])
FIG=scatter(log(PARA.H0),[(dpdT(:,1,14)./dpdT(:,1,24))])
FIG=scatter(log(PARA.H0),[(dwdT(:,1,14)./dwdT(:,1,24))])

%
% iota_ch
%
figure
    FIG=scatter((PARA.iota),[(U_ch_ct10(:,1,15)./U_ch_ct10(:,1,25))])
    xlabel('Share paid to global portfolio ($ \iota_n $)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\W_dUdT_i0.png']);

figure
    FIG=scatter((PARA.iota),[(U_ch_ct10(:,2,15)./U_ch_ct10(:,2,25))])
    xlabel('Share paid to global portfolio ($ \iota_n $)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\A_dUdT_i0.png']);    

figure
    FIG=scatter((PARA.iota),[(U_ch_t1e6(:,3,15)./U_ch_t1e6(:,3,25))])
    xlabel('Share paid to global portfolio ($ \iota_n $)','interpreter','latex');
    ylabel('Change in welfare ($\hat{V}_n$)','interpreter','latex');
    %yticklabels({''})    
    set(gca,'yticklabel',[])
    saveas(FIG,[path '\output\graphs\margEff\D_dUdT_i0.png']);
    
FIG=scatter((PARA.iota0BACK),[(dvdT(:,1,15)./dvdT(:,1,25))])
FIG=scatter((PARA.iota0BACK),[(dLdT(:,1,15)./dLdT(:,1,25))])
FIG=scatter((PARA.iota0BACK),[(dpdT(:,1,15)./dpdT(:,1,25))])
FIG=scatter((PARA.iota0BACK),[(dwdT(:,1,15)./dwdT(:,1,25))])


stop


